package org.act.manage.controls;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

public class ActionTag extends BodyTagSupport {
        
    protected String label = null;
        
    protected boolean selected = false;
    public boolean getSelected() {
        return (this.selected);
    }
    public void setSelected(boolean selected) {
        this.selected = selected;
    }
    
    protected boolean disabled = false;
    public boolean getDisabled() {
        return (this.disabled);
    }
    public void setDisabled(boolean disabled) {
        this.disabled = disabled;
    }
    
    protected String url = null;
    public String getUrl() {
        return (this.url);
    }
    public void setUrl(String url) {
        this.url = url;
    }
        
    public int doStartTag() throws JspException {
                this.label = null;
                return (EVAL_BODY_BUFFERED);
    }
    
    public int doAfterBody() throws JspException {
        String label = bodyContent.getString();
        if (label != null) {
            label = label.trim();
            if (label.length() > 0)
                this.label = label;
        }
        return (SKIP_BODY);
    }
    
    public int doEndTag() throws JspException {
                Tag parent = getParent();
        while ((parent != null) && !(parent instanceof ActionsTag)) {
            parent = parent.getParent();
        }
        if ((parent == null) || !(parent instanceof ActionsTag))
            throw new JspException("Must be nested in an ActionsTag isntance");
        ActionsTag actions = (ActionsTag) parent;
                        HttpServletRequest request =
            (HttpServletRequest) pageContext.getRequest();
        HttpServletResponse response =
            (HttpServletResponse) pageContext.getResponse();
        String path = null;
        if ((url != null) && (url.startsWith("/"))) {
            path = request.getContextPath() + url;
        } else {
            path = url;
        }
        actions.addAction(label, selected, disabled,
                          response.encodeURL(path));
        return (EVAL_PAGE);
    }
    
    public void release() {
        this.label = null;
        this.selected = false;
        this.disabled = false;
        this.url = null;
    }
}
