package org.act.manage.controls;
import org.apache.struts.action.*;
import javax.servlet.http.*;
import javax.servlet.ServletException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;
import org.act.manage.RBACManager;

public class SetUpTreeAction
    extends Action
{
    public static final String DOMAIN_KEY = "domain";
    public static final int INIT_PLUGIN_MAX = 10;
    public static final String TREEBUILDER_KEY = "treebuilders";
    public static final String ROOTNODENAME_KEY = "rootnodename";
       
    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws
        IOException, ServletException
    {
        ActionServlet servlet = getServlet();
                        String rootnodeName =
            (String)servlet.getServletConfig().getInitParameter(
                ROOTNODENAME_KEY);
        String domain =
            (String)servlet.getServletConfig().getInitParameter(DOMAIN_KEY);
                                TreeControlNode root =
            new TreeControlNode("ROOT-NODE",
                                null, rootnodeName,
                                "setUpTree.do?select=ROOT-NODE",
                                "content", true, domain);
        TreeControl control = new TreeControl(root);
        Class treeBuilderImpl;
        TreeBuilder treeBuilderBase;
        RBACManager rbac = (RBACManager)request.getSession().getAttribute(
            "ACTRBAC");
        if(rbac == null)
            return (mapping.findForward("Blank"));
        ArrayList treeBuilders = rbac.getTreeBuilders();
        int i = 0;
        for (i = 0; i < treeBuilders.size(); i++)
        {
            try
            {
                treeBuilderImpl = Class.forName( (String)treeBuilders.get(
                    i));
                treeBuilderBase =
                    (TreeBuilder)treeBuilderImpl.newInstance();
                treeBuilderBase.buildTree(control, servlet, request);
            }
            catch (Throwable t)
            {
                            }
        }
        HttpSession session = request.getSession();
        session.setAttribute("treeControl", control);
                session.setAttribute("TreeRoot",root);
                String name = request.getParameter("select");
        if (name != null)
        {
            control.selectNode(name);
                        return (mapping.findForward("Blank"));
        }
        return (mapping.findForward("SetUpTree"));
    }
}
