
package org.act.manage.log;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class LogInfoTreeBuilder implements SubTreeBuilder{
	public LogInfoTreeBuilder() {
       try {
           jbInit();
       }
       catch (Exception ex) {
           ex.printStackTrace();
       }
   }
 
   public void buildTree(TreeControlNode treeNode,
                         ActionServlet servlet,
                         HttpServletRequest request) {
       MessageResources resources = (MessageResources)
           servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
       HttpSession session = request.getSession();
       Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
       try {
           addSubtree(treeNode, resources, locale);
       } catch(Exception e) {
           e.printStackTrace();
       }
   }
      
   protected void addSubtree(TreeControlNode root,
                             MessageResources resources,
                             Locale locale)
       throws Exception {
       
       TreeControlNode subtree = new TreeControlNode
           ("WSRuntime_LogInfo",
            "XLinker.gif",
            "LogInfo",
            "log/logInfo.jsp",
            "content",
            Utils.checkTreeNodeState("WSRuntime_LogInfo",false),
            "Services");
       root.addChild(subtree);
   }
   private void jbInit() throws Exception {
   }
}
