
package org.act.manage.util;
import java.lang.reflect.Array;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.xml.soap.SOAPElement;

public class JavaUtils {
		public static final char NL = '\n';
	public static final char CR = '\r';
	
	public static final String LS = System.getProperty("line.separator",
			(new Character(NL)).toString());
	
	
	public static Class getWrapperClass(Class primitive) {
		if (primitive == int.class)
			return java.lang.Integer.class;
		else if (primitive == short.class)
			return java.lang.Short.class;
		else if (primitive == boolean.class)
			return java.lang.Boolean.class;
		else if (primitive == byte.class)
			return java.lang.Byte.class;
		else if (primitive == long.class)
			return java.lang.Long.class;
		else if (primitive == double.class)
			return java.lang.Double.class;
		else if (primitive == float.class)
			return java.lang.Float.class;
		else if (primitive == char.class)
			return java.lang.Character.class;
		return null;
	}
	
	public static String getWrapper(String primitive) {
		if (primitive.equals("int"))
			return "Integer";
		else if (primitive.equals("short"))
			return "Short";
		else if (primitive.equals("boolean"))
			return "Boolean";
		else if (primitive.equals("byte"))
			return "Byte";
		else if (primitive.equals("long"))
			return "Long";
		else if (primitive.equals("double"))
			return "Double";
		else if (primitive.equals("float"))
			return "Float";
		else if (primitive.equals("char"))
			return "Character";
		return null;
	}
	
	public static Class getPrimitiveClassByName(String strName) {
		if (strName.equals("int"))
			return int.class;
		else if (strName.equals("short"))
			return short.class;
		else if (strName.equals("boolean"))
			return boolean.class;
		else if (strName.equals("byte"))
			return byte.class;
		else if (strName.equals("long"))
			return long.class;
		else if (strName.equals("double"))
			return double.class;
		else if (strName.equals("float"))
			return float.class;
		else if (strName.equals("char"))
			return char.class;
		return null;
	}
	
	public static Class getPrimitiveClass(Class wrapper) {
		if (wrapper == java.lang.Integer.class)
			return int.class;
		else if (wrapper == java.lang.Short.class)
			return short.class;
		else if (wrapper == java.lang.Boolean.class)
			return boolean.class;
		else if (wrapper == java.lang.Byte.class)
			return byte.class;
		else if (wrapper == java.lang.Long.class)
			return long.class;
		else if (wrapper == java.lang.Double.class)
			return double.class;
		else if (wrapper == java.lang.Float.class)
			return float.class;
		else if (wrapper == java.lang.Character.class)
			return char.class;
		return null;
	}

	public static Object convert(Object arg, Class destClass) {
		if (destClass == null) {
			return arg;
		}
		if (arg != null && destClass.isAssignableFrom(arg.getClass())) {
			return arg;
		}
				if (arg instanceof HashMap && destClass == Hashtable.class) {
			return new Hashtable((HashMap) arg);
		}
								if (arg != null
				&& destClass.isArray()
				&& !destClass.getComponentType().equals(Object.class)
				&& !destClass.getComponentType().isArray()
				&& destClass.getComponentType()
						.isAssignableFrom(arg.getClass())) {
			Object array = Array.newInstance(destClass.getComponentType(), 1);
			Array.set(array, 0, arg);
			return array;
		}
				if (!(arg instanceof Collection || (arg != null && arg.getClass()
				.isArray()))) {
			return arg;
		}
				if (arg == null) {
			return arg;
		}
				int length = 0;
		if (arg.getClass().isArray()) {
			length = Array.getLength(arg);
		} else {
			length = ((Collection) arg).size();
		}
		Object destValue = null;
		if (destClass.isArray()) {
			if (destClass.getComponentType().isPrimitive()) {
				Object array = Array.newInstance(destClass.getComponentType(),
						length);
								if (arg.getClass().isArray()) {
					for (int i = 0; i < length; i++) {
						Array.set(array, i, Array.get(arg, i));
					}
				} else {
					int idx = 0;
					for (Iterator i = ((Collection) arg).iterator(); i
							.hasNext();) {
						Array.set(array, idx++, i.next());
					}
				}
				destValue = array;
			} else {
				Object[] array;
				try {
					array = (Object[]) Array.newInstance(destClass
							.getComponentType(), length);
				} catch (Exception e) {
					return arg;
				}
								if (arg.getClass().isArray()) {
					for (int i = 0; i < length; i++) {
						array[i] = convert(Array.get(arg, i), destClass
								.getComponentType());
					}
				} else {
					int idx = 0;
					for (Iterator i = ((Collection) arg).iterator(); i
							.hasNext();) {
						array[idx++] = convert(i.next(), destClass
								.getComponentType());
					}
				}
				destValue = array;
			}
		} else if (Collection.class.isAssignableFrom(destClass)) {
			Collection newList = null;
			try {
												if (destClass == Collection.class || destClass == List.class) {
					newList = new ArrayList();
				} else if (destClass == Set.class) {
					newList = new HashSet();
				} else {
					newList = (Collection) destClass.newInstance();
				}
			} catch (Exception e) {
								return arg;
			}
			if (arg.getClass().isArray()) {
				for (int j = 0; j < length; j++) {
					newList.add(Array.get(arg, j));
				}
			} else {
				for (Iterator j = ((Collection) arg).iterator(); j.hasNext();) {
					newList.add(j.next());
				}
			}
			destValue = newList;
		} else {
			destValue = arg;
		}
		return destValue;
	}
	
	public static String getLoadableClassName(String text) {
		if (text == null || text.indexOf("[") < 0 || text.charAt(0) == '[')
			return text;
		String className = text.substring(0, text.indexOf("["));
		if (className.equals("byte"))
			className = "B";
		else if (className.equals("char"))
			className = "C";
		else if (className.equals("double"))
			className = "D";
		else if (className.equals("float"))
			className = "F";
		else if (className.equals("int"))
			className = "I";
		else if (className.equals("long"))
			className = "J";
		else if (className.equals("short"))
			className = "S";
		else if (className.equals("boolean"))
			className = "Z";
		else
			className = "L" + className + ";";
		int i = text.indexOf("]");
		while (i > 0) {
			className = "[" + className;
			i = text.indexOf("]", i + 1);
		}
		return className;
	}
	
	public static String getTextClassName(String text) {
		if (text == null || text.indexOf("[") != 0)
			return text;
		String className = "";
		int index = 0;
		while (index < text.length() && text.charAt(index) == '[') {
			index++;
			className += "[]";
		}
		if (index < text.length()) {
			if (text.charAt(index) == 'B')
				className = "byte" + className;
			else if (text.charAt(index) == 'C')
				className = "char" + className;
			else if (text.charAt(index) == 'D')
				className = "double" + className;
			else if (text.charAt(index) == 'F')
				className = "float" + className;
			else if (text.charAt(index) == 'I')
				className = "int" + className;
			else if (text.charAt(index) == 'J')
				className = "long" + className;
			else if (text.charAt(index) == 'S')
				className = "short" + className;
			else if (text.charAt(index) == 'Z')
				className = "boolean" + className;
			else {
				className = text.substring(index + 1, text.indexOf(";"))
						+ className;
			}
		}
		return className;
	}
	
	public static boolean isEnumClass(Class cls) {
		try {
			java.lang.reflect.Method m = cls.getMethod("getValue", null);
			java.lang.reflect.Method m2 = cls.getMethod("toString", null);
			java.lang.reflect.Method m3 = cls.getMethod("fromString",
					new Class[] { java.lang.String.class });
			if (m != null
					&& m2 != null
					&& m3 != null
					&& cls.getMethod("fromValue", new Class[] { m
							.getReturnType() }) != null) {
				try {
					if (cls.getMethod("setValue", new Class[] { m
							.getReturnType() }) == null)
						return true;
					return false;
				} catch (java.lang.NoSuchMethodException e) {
					return true; 								 				}
			}
		} catch (java.lang.NoSuchMethodException e) {
		}
		return false;
	}
	
	public static boolean isBeanClass(Class javaType) {
				if (javaType.isArray() || javaType.isPrimitive()) {
			return false;
		}
		if (javaType.getName().startsWith("java.")
				|| javaType.getName().startsWith("javax.")) {
			return false;
		}
				if (JavaUtils.isEnumClass(javaType)) {
			return true;
		}
				if (!java.lang.Throwable.class.isAssignableFrom(javaType)) {
			try {
				javaType.getConstructor(new Class[] {});
			} catch (java.lang.NoSuchMethodException e) {
				return false;
			}
		}
				Class superClass = javaType.getSuperclass();
		if (superClass != null && superClass != java.lang.Object.class
				&& superClass != java.lang.Exception.class
				&& superClass != java.lang.Throwable.class
				&& superClass != java.rmi.RemoteException.class) {
			if (!isBeanClass(superClass)) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean isConvertable(Object obj, Class dest) {
		return isConvertable(obj, dest, false);
	}
	
	public static boolean isConvertable(Object obj, Class dest,
			boolean isEncoded) {
		Class src = null;
		if (dest == null)
			return false;
		if (obj != null) {
			if (obj instanceof Class) {
				src = (Class) obj;
			} else {
				src = obj.getClass();
			}
		} else {
			if (!dest.isPrimitive())
				return true;
		}
		if (src != null) {
						if (dest.isAssignableFrom(src))
				return true;
						if (java.util.Map.class.isAssignableFrom(dest)
					&& java.util.Map.class.isAssignableFrom(src)) {
				return true;
			}
						if (getWrapperClass(src) == dest)
				return true;
			if (getWrapperClass(dest) == src)
				return true;
						if ((Collection.class.isAssignableFrom(src) || src.isArray())
					&& (Collection.class.isAssignableFrom(dest) || dest
							.isArray())
					&& (src.getComponentType() == Object.class
							|| src.getComponentType() == null
							|| dest.getComponentType() == Object.class
							|| dest.getComponentType() == null || isConvertable(
							src.getComponentType(), dest.getComponentType())))
				return true;
									if (!isEncoded && dest.isArray()
					&& !dest.getComponentType().equals(Object.class)
					&& dest.getComponentType().isAssignableFrom(src))
				return true;
						if (Calendar.class.isAssignableFrom(src) && dest == Date.class)
				return true;
						if (Calendar.class.isAssignableFrom(src)
					&& dest == java.sql.Date.class)
				return true;
		}
		if (src == null)
			return false;
		if (src.isPrimitive()) {
			return isConvertable(getWrapperClass(src), dest);
		}
		return false;
	}
	
	
	public static String extractShortClassName(String className) {
		if (null != className) {
			return className.substring(className.lastIndexOf('.') + 1);
		}
		return null;
	}
		
	public static boolean isMethodOfDocumentStyle(Method method) {
		return (method != null && method.getReturnType() == SOAPElement[].class
				&& method.getParameterTypes().length == 1 && method
				.getParameterTypes()[0] == SOAPElement[].class);
	}
	}
