
package org.act.manage.workflow;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.conf.WorkflowConfigTreeBuilder;
import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeBuilder;
import org.act.manage.controls.TreeControl;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.jvm.WorkflowJVMTreeBuilder;
import org.act.manage.log.WorkflowLogInfoTreeBuilder;
import org.act.manage.objectPool.WorkflowObjectPoolTreeBuilder;
import org.act.manage.soap.WorkflowSOAPTreeBuilder;
import org.act.manage.threadpool.WorkflowThreadpoolTreeBuilder;
import org.act.manage.util.Utils;
import org.act.manage.workflow.instance.InstanceTreeBuilder;
import org.act.manage.workflow.process.ProcessTreeBuilder;
import org.act.manage.workflow.statistic.StatisticTreeBuilder;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class WorkflowTreeBuilder implements TreeBuilder
{
    
    public void buildTree(TreeControl treeControl, ActionServlet servlet
                          , HttpServletRequest request)
    {
        MessageResources resources = (MessageResources)servlet.
                                     getServletContext().getAttribute(Globals.
            MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
        TreeControlNode wfNode = new TreeControlNode
                                  ("Workflow",
                                   "Workflow.gif",
                                   resources.getMessage(locale
            , "wf.treeBuilder.Workflow"),
                                   "treeControlAction.do?tree=Workflow&select=Workflow",
                                   "_self",
                                   Utils.checkTreeNodeState("Workflow", true),
                                   "Workflow");
        treeControl.getRoot().addChild(wfNode);
        SubTreeBuilder builder = new InstanceTreeBuilder();
        builder.buildTree(wfNode, servlet, request);
        builder = new ProcessTreeBuilder();
        builder.buildTree(wfNode, servlet, request);
        builder = new StatisticTreeBuilder();
        builder.buildTree(wfNode, servlet, request);
        builder = new WorkflowConfigTreeBuilder();
        builder.buildTree(wfNode, servlet, request);
        builder = new WorkflowJVMTreeBuilder();
        builder.buildTree(wfNode,servlet,request);
        builder = new WorkflowThreadpoolTreeBuilder();
        builder.buildTree(wfNode,servlet,request);
        builder = new WorkflowObjectPoolTreeBuilder();
        builder.buildTree(wfNode,servlet,request);
        builder = new WorkflowSOAPTreeBuilder();
        builder.buildTree(wfNode,servlet,request);
    }
}
