
package org.act.manage.workflow.instance;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class InstanceTreeBuilder implements SubTreeBuilder 
{
	 
    public void buildTree(TreeControlNode treeNode, ActionServlet servlet
                          , HttpServletRequest request)
    {
        MessageResources resources = (MessageResources)
                                     servlet.getServletContext().getAttribute(
                                         Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
        TreeControlNode subTree = new TreeControlNode
                                  ("Workflow_Instance",
                                   "Workflow.gif",
                                   resources.getMessage(locale
            , "wf.process.title.process"),
                                   "workflow/instance/ListInstance.do",
                                   "content",
                                   Utils.checkTreeNodeState("Workflow_Instance", false),
                                   "Workflow_Statistic");
        treeNode.addChild(subTree);
        String serverType=(String)request.getSession().getAttribute("ServerType");
		String server=(String)request.getSession().getAttribute("Server");
        CallWfEngine callServer=new CallWfEngine
		(ServerInfo.getServerAddress(server,serverType).getAddress());
	
        String result="";
	    try{
        	result=callServer.getDeployedInstances();
        }
        catch(Exception e)
		{
        	e.printStackTrace();
		}
		String instanceNames[]=result.split("#");
		for (int i=1 ;i<instanceNames.length;i++)
		{
			String instanceName = instanceNames[i];
	        TreeControlNode serviceNode = new TreeControlNode
	                    ("WorkFlowInstance_"+instanceName,
	                     "Workflow.gif",
	                     instanceName,
	                     "workflow/instance/ShowInstance.do?Type="+instanceName,
	                     "content",
	                     Utils.checkTreeNodeState(instanceName,false),
	                     "Services");
	        subTree.addChild(serviceNode);
		}
		TreeControlNode serviceNode = new TreeControlNode("DeployWF",
				"Workflow.gif", resources.getMessage(locale,
						"instance.treeBuilder.deploynewNode"),
				"workflow/deploy/upload.do", "content", Utils
						.checkTreeNodeState("DeployWF", false), "Services");
		subTree.addChild(serviceNode);
        
        
    }
}
