
package org.act.manage.workflow.instance;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.Utils;
import org.act.manage.workflow.meta.ActivityInfoMeta;
import org.act.manage.workflow.meta.ProcessInfoMeta;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ShowInstanceAction extends Action {
	
	private boolean needUpdateTree = false;
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException 
	{
	
		String type = "";
        try
        {
            ArrayList al = new ArrayList();
            type = request.getParameter("Type");
            String pageNum = request.getParameter("PageNum");
            int page;
            if (pageNum == null || pageNum.equals(""))
                page = 1;
            else
                page = new Integer(pageNum).intValue();
                                                String serverType=(String)request.getSession().getAttribute("ServerType");
    		String server=(String)request.getSession().getAttribute("Server");
            CallWfEngine callServer=new CallWfEngine
    		(ServerInfo.getServerAddress(server,serverType).getAddress());
            String processes=callServer.getActiveInstance(type);
            String pro[]=processes.split("#");
            for(int i=1 ;i<pro.length;i++)
            {
            	ProcessInfoMeta info = new ProcessInfoMeta();
                String instance[]=pro[i].split("~");
                info.setType(instance[0]);
            	info.setProcessID(instance[1]);
                info.setBeginTime(instance[2]);
                info.setStatus(makeStatusString(instance[3]));
                String activity[]=instance[4].split("`");
                ArrayList acts=new ArrayList();
                for (int j=0;j<activity.length/5;j++)
                {
                	ActivityInfoMeta act=new ActivityInfoMeta();
                	act.setName(activity[j*0+0]);
                	act.setType(activity[j*0+1]);
                	act.setBeginTime(activity[j*0+2]);
                	if(activity[j*0+3].equalsIgnoreCase("null"))
                		act.setEndTime("");
                	else
                		act.setEndTime(activity[j*0+3]);
                	act.setStatus(activity[j*0+4]);
                	acts.add(act);
                	
                }
                info.setActivity(acts);
                al.add(info);
            }
            
            request.getSession().setAttribute("WF_History_Type", type);
                        request.getSession().setAttribute("WF_ProcessList", al);
            request.getSession().setAttribute("WF_Page_Process"
                                              , new Integer(page));
            request.getSession().setAttribute("WF_Page_ProcessItem"
                                              , new Integer( (page - 1) * Utils.
                mPageItemCount));
            request.getSession().setAttribute("Util_PageSize"
                                              , new Integer(Utils.
                mPageItemCount));
                    }
        catch (Exception ex)
        {
                        request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
                                                request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        if (needUpdateTree)
        {
            needUpdateTree = false;
            request.getSession().setAttribute("Util_AfterUpdateTree",
                                              "/workflow/process/processInstances.jsp");
            return mapping.findForward("UpdateTree");
        }
        else
            return mapping.findForward("Instances");
    }
        private void setHistorySession(HttpServletRequest request, String type) throws
        Exception
    {
        String hisTypeName = (String)request.getSession().getAttribute(
            "WF_History_Type");
        if (hisTypeName == null || !hisTypeName.equals(type))
        {
            request.getSession().setAttribute("WF_History_Type", type);
            request.getSession().setAttribute("WF_History_Process", null);
                        request.getSession().setAttribute("WF_History_TransactionID", null);
                                    needUpdateTree = true;
        }
    }
        private String makeStatusString(String oneInfo)
    {
        String status = oneInfo;
        if (status.equalsIgnoreCase("created"))
            return AdminResBundle.getMessage("wf.process.table.status.created");
        else if (status.equalsIgnoreCase("enabled"))
            return AdminResBundle.getMessage("wf.process.table.status.enabled");
        else if (status.equalsIgnoreCase("isShutdown"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.isShutdown") ;
        else if (status.equalsIgnoreCase("manualpause"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.manualpause");
        else if (status.equalsIgnoreCase("disabled"))
            return AdminResBundle.getMessage("wf.process.table.status.disabled");
        else if (status.equalsIgnoreCase("completed"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.completed");
        else if (status.equalsIgnoreCase("running"))
            return AdminResBundle.getMessage("wf.process.table.status.running");
        else if (status.equalsIgnoreCase("passivate"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.passivate");
        else if (status.equalsIgnoreCase("activate"))
            return AdminResBundle.getMessage("wf.process.table.status.activate");
        else if (status.equalsIgnoreCase("sharpen"))
            return AdminResBundle.getMessage("wf.process.table.status.sharpen");
        else
            return " ";
    }
}
