
package org.act.manage.workflow.process;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FilterOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.Utils;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.metaset.MetasetParser;
import org.act.wsc.bpel4wsmodeling.bpeldata.Activity;
import org.act.wsc.bpel4wsmodeling.bpeldata.BPELProcess;
import org.act.wsc.bpel4wsmodeling.projectdata.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.StructFigure;
import org.act.wsc.bpel4wsmodeling.utils.ProcessReader;

public class GenerateSvg {
    public final static int INIT_WIDTH=1000;
    public final static int INIT_HEIGHT=700;
    public final static int BORDER_WIDTH=150;
    public final static int BORDER_HEIGHT=20;
    public static final String mImageFilePath = "images\\BPELgraphics";
    private int gWidth=0;
    private int gHeight=0;
	public  String GenerateProSvg(String uri,String type)
    {
    	BPELProcess bp;
    	try{
    		
    		long start = System.currentTimeMillis();
    		CallWfEngine callWf=new CallWfEngine(uri);
    		String bpelFile=callWf.getBpel(type);
    		System.out.println("Tasks invoke Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		InputStream inputStream = new ByteArrayInputStream(bpelFile.getBytes()); 
    		Metaset metaset=MetasetParser.getInstance().parse(inputStream);
    		System.out.println("Tasks creat metaset Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		    		    		bp = new BPELProcess(metaset);   		
    		
    		    		Activity topAct = bp.getActivity();
    		    		 Figure figure = ProcessReader.createFigureByServicesSet(topAct);
    		    		Svg svg = new Svg();
    		int width=0;
    		int height=0;
    		if (figure != null) {
          
                width=figure.getStructWidth()+2*BORDER_WIDTH;
                height=figure.getStructHeight()+2*BORDER_HEIGHT;
                this.gHeight=height;
                this.gWidth=width;
                figure.setX(width/2);
                figure.setY(BORDER_HEIGHT);
                if (figure instanceof StructFigure) {
                    StructFigure sf = (StructFigure) figure;
                    sf.setLayout();
                                        svg=SvgFactory.createSvgByFigure(sf);
                }
            }
    		System.out.println("Tasks draw Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		    		    		String svgFileContent=SvgHead.content;
    		inputStream = new ByteArrayInputStream(svgFileContent.getBytes()); 
    		Metaset SvgFile=MetasetParser.getInstance().parse(inputStream);
    		System.out.println("Tasks creatmetaset Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		Attribute awidth = new Attribute("width",String.valueOf(width));
    		Attribute aheight = new Attribute("height",String.valueOf(height));
    		SvgFile.add(awidth);
    		SvgFile.add(aheight);
    		SvgFile.add(svg.svgSS);
    		
    		
    		String embedSvg = SvgFile.toXML();
    		System.out.println(embedSvg);
    		embedSvg=SvgHead.head+embedSvg;
    		String dir = Utils.mACTAdminRoot + "\\" + mImageFilePath;
    		System.out.println(dir);
    		Long time = new Long(System.currentTimeMillis());
            String fileName = time.toString()+".svg";
            
            dir = dir + "\\" + fileName;
            File file=new File(dir);
            FilterOutputStream output = new FilterOutputStream(
					new FileOutputStream(file));
			output.write(embedSvg.getBytes());
			output.close();
            return fileName;
    	}catch(Exception e)
    	{
    		e.printStackTrace();
    		return null;
    	}
    }
	
	public  String GenerateProSvg(String uri,String type,ArrayList al)
    {
    	BPELProcess bp;
    	try{
    		
    		long start = System.currentTimeMillis();
    		CallWfEngine callWf=new CallWfEngine(uri);
    		String bpelFile=callWf.getBpel(type);
    		System.out.println("Tasks invoke Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		InputStream inputStream = new ByteArrayInputStream(bpelFile.getBytes()); 
    		Metaset metaset=MetasetParser.getInstance().parse(inputStream);
    		System.out.println("Tasks creat metaset Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		    		    		bp = new BPELProcess(metaset);   		
    		
    		    		Activity topAct = bp.getActivity();
    		    		 Figure figure = ProcessReader.createFigureByServicesSet(topAct);
    		    		Svg svg = new Svg();
    		int width=0;
    		int height=0;
    		if (figure != null) {
          
                width=figure.getStructWidth()+2*BORDER_WIDTH;
                height=figure.getStructHeight()+2*BORDER_HEIGHT;
                this.gHeight=height;
                this.gWidth=width;
                figure.setX(width/2);
                figure.setY(BORDER_HEIGHT);
                if (figure instanceof StructFigure) {
                    StructFigure sf = (StructFigure) figure;
                    sf.setLayout();
                                        svg=SvgFactory.createSvgByFigure(sf,al);
                }
            }
    		System.out.println("Tasks draw Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		    		    		String svgFileContent=SvgHead.content;
    		inputStream = new ByteArrayInputStream(svgFileContent.getBytes()); 
    		Metaset SvgFile=MetasetParser.getInstance().parse(inputStream);
    		System.out.println("Tasks creatmetaset Time:" + (System.currentTimeMillis()-start)
    				+ " milliseconds\n" );
    		Attribute awidth = new Attribute("width",String.valueOf(width));
    		Attribute aheight = new Attribute("height",String.valueOf(height));
    		SvgFile.add(awidth);
    		SvgFile.add(aheight);
    		SvgFile.add(svg.svgSS);
    		String toolTip="<g id='ToolTip' opacity='0.8' display='none' pointer-events='none'>\n"+
		      "<rect id='tipbox' x='0' y='5' width='88' height='20' rx='2' ry='2' fill='white' stroke='black'/>\n"+
		      "<text id='tipText' x='5' y='20' font-family='Arial' font-size='12'>\n"+
		         "<tspan id='tipTitle' x='5' font-weight='bold'>null</tspan>\n"+
		         "<tspan id='tipType' x='5' dy='1.2em' fill='blue'>null</tspan>\n"+
		         "<tspan id='tipBeginTime' x='5' dy='1.2em' fill='blue'>null</tspan>\n"+
		         "<tspan id='tipEndTime' x='5' dy='1.2em' fill='blue'>null</tspan>\n"+
		         "<tspan id='tipStatus' x='5' dy='1.2em' fill='blue'>null</tspan>\n"+
		         "<tspan id='tipTxid' x='5' dy='1.2em' fill='blue'>null</tspan>\n"+
		      "</text>\n"+
		   "</g>";
		    		inputStream = new ByteArrayInputStream(toolTip.getBytes()); 
		    		Metaset toolTipMetaset=MetasetParser.getInstance().parse(inputStream);
    		SvgFile.add(toolTipMetaset);
    		String embedSvg = SvgFile.toXML();
    		
    		embedSvg=SvgHead.head+embedSvg;
    		
    		
    		System.out.println(embedSvg);
    		String dir = Utils.mACTAdminRoot + "\\" + mImageFilePath;
    		System.out.println(dir);
    		Long time = new Long(System.currentTimeMillis());
            String fileName = time.toString()+".svg";
            
            dir = dir + "\\" + fileName;
            File file=new File(dir);
            FilterOutputStream output = new FilterOutputStream(
					new FileOutputStream(file));
			output.write(embedSvg.getBytes());
			output.close();
            return fileName;
    	}catch(Exception e)
    	{
    		e.printStackTrace();
    		return null;
    	}
    }
    
    public static void main(String args[])
    {
		long start = System.currentTimeMillis();
		GenerateSvg gs=new GenerateSvg();
        String fileName=gs.GenerateProSvg("http://127.0.0.1:8091/SystemInfo","workflowTest11");
    	long end = System.currentTimeMillis();
    	System.out.println("Tasks Time:" + (end - start)
				+ " milliseconds\n" );
    }
	
	public int getGHeight() {
		return gHeight;
	}
	
	public void setGHeight(int height) {
		gHeight = height;
	}
	
	public int getGWidth() {
		return gWidth;
	}
	
	public void setGWidth(int width) {
		gWidth = width;
	}
}
