package org.act.manage.workflow.process;
import java.sql.Connection;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ConnectionDB;
import org.act.manage.util.DateCal;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.workflow.WorkflowException;
import org.act.manage.workflow.db.ProcessInfo;
import org.act.manage.workflow.meta.ProcessInfoMeta;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ProcessListAction
    extends Action
{
    private boolean needUpdateTree = false;
    public ActionForward execute(ActionMapping
                                 mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws
        ServletException
    {
        String type = "";
        try
        {
            
            
            ArrayList al = new ArrayList();
            type = request.getParameter("Type");
            String pageNum = request.getParameter("PageNum");
            int page;
            if (pageNum == null || pageNum.equals(""))
                page = 1;
            else
                page = new Integer(pageNum).intValue();
                        Vector processes;
            String serverType = (String) request.getSession().getAttribute(
			"ServerType");
            String server = (String) request.getSession().getAttribute("Server");
            ServerInfoMeta serverMeta=ServerInfo.getServerAddress(server,serverType);
            Connection connection = new 
				ConnectionDB().getConnection(serverMeta.getDBaddress(),
						serverMeta.getDBUser(),serverMeta.getDBPWD());
            processes = ProcessInfo.queryTypeInfo(connection,type);
            connection.close();
            if (processes == null)
                throw new WorkflowException(AdminResBundle.getMessage(
                    "util.error.nullRes", "Processes"));
            int num=processes.size();
            long sum=0;
                        Vector oneInfo;
            for (int i = 0; i < processes.size(); i++)
            {
                oneInfo = (Vector)processes.get(i);
                ProcessInfoMeta info = new ProcessInfoMeta();
                info.setProcessID(oneInfo.get(0).toString());
                info.setBeginTime(oneInfo.get(2).toString());
                if (null == oneInfo.get(3) || oneInfo.get(3).equals(""))
                {
                	info.setEndTime(" ");
                	num--;
                }
                else
                {
                	info.setEndTime(oneInfo.get(3).toString());
                	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
                	Date date1=null,date2=null;
                	try {
                		date1= sdf.parse(oneInfo.get(2).toString());
                        date2 = sdf.parse(oneInfo.get(3).toString());
                     }
                     catch(ParseException e) {
                        System.out.println("Unable to parse " );
                     }
                     long executeTime=DateCal.ElapsedMillis(date1,date2);
                     info.setExecuteTime(executeTime);
                	sum=sum+executeTime;
                }
                info.setStatus(makeStatusString(oneInfo));
                
                al.add(info);
            }
            long avgTime=(sum/num);
            String avgT=DateCal.calcHMS(avgTime);
            request.getSession().setAttribute("WF_ProcessAVGTime", avgT);
                        request.getSession().setAttribute("WF_ProcessList", al);
            request.getSession().setAttribute("WF_Page_Process"
                                              , new Integer(page));
            request.getSession().setAttribute("WF_Page_ProcessItem"
                                              , new Integer( (page - 1) * Utils.
                mPageItemCount));
            request.getSession().setAttribute("Util_PageSize"
                                              , new Integer(Utils.
                mPageItemCount));
            setHistorySession(request, type);
        }
        catch (Exception ex)
        {
                        request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
            String tmp = AdminResBundle.getMessage("wf.process.error.list" , type);
            tmp += " " + ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        if (needUpdateTree)
        {
            needUpdateTree = false;
            request.getSession().setAttribute("Util_AfterUpdateTree",
                                              "/workflow/process/processInstances.jsp");
            return mapping.findForward("UpdateTree");
        }
        else
            return mapping.findForward("Forward");
    }
        private void setHistorySession(HttpServletRequest request, String type) throws
        Exception
    {
        String hisTypeName = (String)request.getSession().getAttribute(
            "WF_History_Type");
        if (hisTypeName == null || !hisTypeName.equals(type))
        {
            request.getSession().setAttribute("WF_History_Type", type);
            request.getSession().setAttribute("WF_History_Process", null);
                        request.getSession().setAttribute("WF_History_TransactionID", null);
                                    needUpdateTree = true;
        }
    }
        private String makeStatusString(Vector oneInfo)
    {
        String status = oneInfo.elementAt(4).toString();
        if (status.equalsIgnoreCase("created"))
            return AdminResBundle.getMessage("wf.process.table.status.created");
        else if (status.equalsIgnoreCase("enabled"))
            return AdminResBundle.getMessage("wf.process.table.status.enabled");
        else if (status.equalsIgnoreCase("isShutdown"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.isShutdown") ;
        else if (status.equalsIgnoreCase("manualpause"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.manualpause");
        else if (status.equalsIgnoreCase("disabled"))
            return AdminResBundle.getMessage("wf.process.table.status.disabled");
        else if (status.equalsIgnoreCase("completed"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.completed");
        else if (status.equalsIgnoreCase("running"))
            return AdminResBundle.getMessage("wf.process.table.status.running");
        else if (status.equalsIgnoreCase("passivate"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.passivate");
        else if (status.equalsIgnoreCase("activate"))
            return AdminResBundle.getMessage("wf.process.table.status.activate");
        else if (status.equalsIgnoreCase("sharpen"))
            return AdminResBundle.getMessage("wf.process.table.status.sharpen");
        else
            return " ";
    }
}
