      var SVGDocument = null;
      var SVGRoot = null;
      var SVGViewBox = null;
      var svgns = 'http://www.w3.org/2000/svg';
      var xlinkns = 'http://www.w3.org/1999/xlink';
      var toolTip = null;
      var TrueCoords = null;
      var tipBox = null;
      var tipText = null;
      var tipTitle = null;
      var tipDesc = null;
      var lastElement = null;
      var titleText = '';
      var titleDesc = '';
      
      function Init(evt)
      {
         //alert("Init");
         SVGDocument = evt.target.ownerDocument;
         //alert(SVGDocument);
         SVGRoot = document.documentElement;
         //alert(SVGRoot);
         TrueCoords = SVGRoot.createSVGPoint();
         toolTip = SVGDocument.getElementById('ToolTip');
         //alert(toolTip);
         tipBox = SVGDocument.getElementById('tipbox');
         tipText = SVGDocument.getElementById('tipText');
         tipTitle = SVGDocument.getElementById('tipTitle');
         tipType = SVGDocument.getElementById('tipType');
         tipBeginTime=SVGDocument.getElementById('tipBeginTime');
         tipEndTime=SVGDocument.getElementById('tipEndTime');
         tipStatus=SVGDocument.getElementById('tipStatus');
         tipTxid=SVGDocument.getElementById('tipTxid');
         //alert(tipStatus);
      };
      function GetTrueCoords(evt)
      {
         //alert("GetTrueCoords");
         // find the current zoom level and pan setting, and adjust the reported
         //    mouse position accordingly
         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         TrueCoords.x = (evt.clientX - translation.x)/newScale;
         TrueCoords.y = (evt.clientY - translation.y)/newScale;
      };
      function ShowTooltip(evt, turnOn)
      {
         //alert("ShowTooltip"+turnOn);
         try
         {
            if (!evt || !turnOn)
            {
               toolTip.setAttributeNS(null, 'display', 'none');
            }
            else
            {
               var tipScale = 1/SVGRoot.currentScale;
               var textWidth = 0;
               var tspanWidth = 0;
               var boxHeight = 20;
               tipBox.setAttributeNS(null, 'transform', 'scale(' + tipScale + ',' + tipScale + ')' );
               tipText.setAttributeNS(null, 'transform', 'scale(' + tipScale + ',' + tipScale + ')' );
               var targetElement = evt.target;
               //alert(targetTitle);
               if ( lastElement != targetElement )
               {
                  var targetTitle = targetElement.getAttributeNS(null, 'id');
                  //alert(targetTitle);
                  titleText = null;
                  if ( targetTitle )
                  {
                     titleText = targetTitle;
                     //alert(titleText);
                  }
                  var targetBegintime = targetElement.getAttributeNS(null, 'beginTime');
                  //alert(targetBegintime);
                  titleBegintime = null;
                  if ( targetBegintime )
                  {
                     titleBegintime = "BeginTime: "+targetBegintime;
                     //alert(titleBegintime);
                  }
                  var targetEndTime = targetElement.getAttributeNS(null, 'endTime');
                  //alert(targetEndTime);
                  titleEndTime = null;
                  if ( targetEndTime )
                  {
                     titleEndTime ="EndTime: "+targetEndTime;
                     //alert(titleEndTime);
                  }
                  var targetType = targetElement.getAttributeNS(null, 'type');
                  //alert(targeType);
                  titleType = null;
                  if ( targetType )
                  {
                     titleType ="Type: "+targetType;
                     //alert(titleType);
                  }
                  
                  var targetStatus = targetElement.getAttributeNS(null, 'status');
                  //alert(targetStatus);
                  titleStatus = null;
                  if ( targetStatus )
                  {
                     titleStatus ="Status: "+targetStatus;
                     //alert(titleStatus);
                  }
                  var targetTxid = targetElement.getAttributeNS(null, 'txid');
                  //alert(targetStatus);
                  titleTxid = null;
                  if ( targetTxid )
                  {
                     titleTxid ="TxID: "+targetTxid;
                     //alert(titleStatus);
                  }
                  if ( !titleText )
                  {
                     //alert(titleText+"null");
                     tipTitle.firstChild.nodeValue = null;
                     tipType.firstChild.nodeValue = null;
						         tipBeginTime.firstChild.nodeValue=null;
						         tipEndTime.firstChild.nodeValue=null;
						         tipStatus.firstChild.nodeValue=null;
						         tipTxid.firstChild.nodeValue=null;
                  }
                  else
                  {
                     tipTitle.firstChild.nodeValue = titleText;
                     //alert(titleText);
                     tipType.firstChild.nodeValue = titleType;
                     //alert(tipType.firstChild.nodeValue);
						         tipBeginTime.firstChild.nodeValue=titleBegintime;
						         //alert(2);
						         
						         tipEndTime.firstChild.nodeValue=titleEndTime;
						         //alert(3);
						         tipStatus.firstChild.nodeValue=titleStatus;
						         tipTxid.firstChild.nodeValue=titleTxid;
                  }
               }
               if ( titleText  )
               {
                  var xPos = TrueCoords.x + (10 * tipScale);
                  var yPos = TrueCoords.y + (10 * tipScale);
                  //alert(xPos);
                  //return rectangle around object as SVGRect object
                  var outline = tipText.getBBox();
                  
                  tipBox.setAttributeNS(null, 'width', Number(outline.width) + 10);
                  tipBox.setAttributeNS(null, 'height', Number(outline.height) + 10);
                  toolTip.setAttributeNS(null, 'transform', 'translate(' + xPos + ',' + yPos + ')');
                  toolTip.setAttributeNS(null, 'display', 'inline');
               }
            }
         }
         catch(er){}
       };
       
       function SetTime(name,beginTime,endTime,status)
       {
       		alert('begin');
       		var targetElement=SVGDocument.getElementById(name);
       		targetElement.setAttribute('beginTime',beginTime);
       		targetElement.setAttribute('endTime',endTime);
       		targetElement.setAttribute('status',status);
       		var targetIcon = targetElement.getAttributeNS(null, 'xlink:href');
          var i=targetIcon.indexOf('_');
          var iconName='';
          if(i!=-1)
          {
          	iconName=targetIcon.substring(0,targetIcon.indexOf('_'));
          //alert(iconName);
          
          }
        	else
        	{
        			iconName=targetIcon+'_';
        	}
       		targetElement.setAttribute('xlink:href',iconName+status);
       }
       
       function SetTx(name,beginTime,endTime,status,txID)
       {
       		var targetElement=SVGDocument.getElementById(name);
       		targetElement.setAttribute('beginTime',beginTime);
       		targetElement.setAttribute('endTime',endTime);
       		targetElement.setAttribute('status',status);
       		targetElement.setAttribute('status',txid);
       		var targetIcon = targetElement.getAttributeNS(null, 'xlink:href');
          var i=targetIcon.indexOf('_');
          var iconName='';
          if(i!=-1)
          {
          	iconName=targetIcon.substring(0,targetIcon.indexOf('_'));
          //alert(iconName);
          
          }
        	else
        	{
        			iconName=targetIcon+'_';
        	}
       		targetElement.setAttribute('xlink:href',iconName+status);
       }